/* Elvira Bluetooth FTP 
 * Copyright (C) 2007  Alberto Salas Bragado
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef COMMON_OP_H_
#define COMMON_OP_H_

#include <stdio.h>
#include <unistd.h>
#include "../adaptation/bftp_client.h"
#include "../adaptation/fs_local.h"

#define FILE_FAVORITES "res/favorites"

#define COP_OK 0
#define COP_CONN -1
#define COP_DISCONN -2
#define COP_FF_OPENW -3
#define COP_FF_OPENR -4
#define COP_FF_WRITE -5
#define COP_UL -6
#define COP_DL -7
#define COP_DEL -8
#define COP_MD -9
#define COP_RD -10
#define COP_LIST -11
#define COP_SCH -12

int connect_to(device_t *disp);
int disconnect();
int is_connected();
int device_search(device_t **list);
int writeFavorites(device_t *favorites, int numfavorites);
int loadFavorites(device_t **favorites, int *numfavorites);
int uploadFile(char *local, char *remote);
int downloadFile(char *local, char *remote);
int deleteLocalFile(char *file);
int deleteRemoteFile(char *file);
int mkdirLocal(char *name);
int mkdirRemote(char *name);
int deleteLocalDir(char *name);
int deleteRemoteDir(char *name);
int listRemoteDir(char *name, file_t **list);
int listLocalDir(char *name, file_t **list);
int permsLocalRead(char *name);
int permsLocalWrite(char *name);
int existLocal(char *name);
int existRemote(char *name);

#endif /*COMMON_OP_H_*/
